.\" $NetBSD: gem.4,v 1.8 2008/09/15 20:03:18 jdc Exp $
.\"
.\" Copyright (c) 2002 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd September 15, 2008
.Dt GEM 4
.Os
.Sh NAME
.Nm gem
.Nd ERI/GEM/GMAC Ethernet device driver
.Sh SYNOPSIS
.Cd "gem* at pci? dev ? function ?"
.Cd "gem* at sbus? slot ? offset ?"
.Pp
Configuration of PHYs may also be necessary.
See
.Xr mii 4 .
.Sh DESCRIPTION
The
.Nm
driver provides support for the GMac Ethernet hardware found mostly in
the last Apple PowerBooks G3s and most G4-based Apple hardware, as
well as many Sun UltraSPARCs.
.Pp
Cards supported by this driver include:
.Bl -bullet -compact -offset indent
.It
Sun GEM gigabit ethernet (SX fibre variants)
.It
Sun ERI 10/100
.It
Apple GMAC
.El
.Pp
The GEM family supports hardware checksumming to assist in computing
IPv4 TCP checksums.
The
.Nm
driver supports this feature of the chip.
See
.Xr ifconfig 8
for information on how to enable this feature.
.Sh SEE ALSO
.Xr bmtphy 4 ,
.Xr ifmedia 4 ,
.Xr intro 4 ,
.Xr mii 4 ,
.Xr ifconfig 8
.Rs
.%T "GEM Gigabit Ethernet ASIC Specification"
.%A Sun Microsystems
.%O http://www.sun.com/processors/manuals/ge.pdf
.Re
.Rs
.%T "Sbus GEM Specification"
.%A Sun Microsystems
.%O http://mediacast.sun.com/users/Barton808/media/gem_sbus-1.pdf
.Re
.Sh HISTORY
The
.Nm
device driver appeared in
.Nx 1.6 .
Support for PCI SX fibre cards was added in
.Nx 5.0 .
Support for SBus SX fibre cards was added in
.Nx 5.0 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Eduardo Horvath
.Aq eeh@NetBSD.org .
SX fibre support was added by
.An Julian Coleman
.Aq jdc@NetBSD.org .
The man page was written by
.An Thomas Klausner
.Aq wiz@NetBSD.org .
.Sh BUGS
The hardware checksumming support does not support IPv4 UDP, although this was
allowed prior to
.Nx 5.0 .
Also, the hardware IPv4 TCP receive checksumming support has bugs, so this is
disabled.
.Pp
On the SX fibre variants of the hardware, the link will stay down if there is
a duplex mismatch.
Also, packet transmission may fail when in
.Cm half-duplex
mode.
